#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%global		_db_backend	ndb
%global		__python	/usr/bin/python3
%define		pyt3num		%(%{__python} --version | cut -d ' ' -f2 | cut -d '.' -f1-2)
#to have a debuginfo package rpm contents.
#global		__debug_package	1
#undefine _missing_build_ids_terminate_build
#-----------------------------------------------------------------------------
Name		:	rpm
Version		:	4.18.1
Release		:	14.4.0.0%{?dist}
Summary		:	The RPM package management system
Group		:	System Environment/Base

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	GPLv2+
URL		:	https://github.com/rpm-software-management/rpm/

Source0		:	%{name}-%{version}.tar.bz2
Source1		:	%{name}-ok_addon.tar.gz
# We either need pandoc in buildroot or this patch in order for man pages to
# actually be installed, choose the latter
Patch0		:	%{name}-%{version}-revert-pandoc-cond.patch


#-----------------------------------------------------------------------------
BuildRequires	:	bzip2
BuildRequires	:	elfutils-devel
BuildRequires	:	elfutils-libelf-devel
BuildRequires	:	file-devel
BuildRequires	:	gawk
BuildRequires	:	gcc
BuildRequires	:	gettext
BuildRequires	:	libcap-devel
BuildRequires	:	libgomp
BuildRequires	:	libdb-devel
BuildRequires	:	lua-devel		>= 5.4
BuildRequires	:	make
BuildRequires	:	ncurses-devel
BuildRequires	:	openssl-devel
BuildRequires	:	popt
BuildRequires	:	readline
BuildRequires	:	sqlite
BuildRequires	:	xz-devel
BuildRequires	:	zlib-devel

Requires(post)	:	file
Requires	:	libdb
Requires(post)	:	libdb-utils
Requires	:	lua-libs		>= 5.4
Requires	:	perl
Requires	:	perl-srpm-macros
Requires	:	python-rpm-macros
Requires	:	python-srpm-macros
Requires(post)	:	xz-libs
Requires	:	debugedit
#-----------------------------------------------------------------------------
#-----------------------------------------------------------------------------
%description
The RPM Package Manager (RPM) is a powerful command line driven
package management system capable of installing, uninstalling,
verifying, querying, and updating software packages. Each software
package consists of an archive of files along with information about
the package like its version, a description, etc.

#-----------------------------------------------------------------------------
%files			-f %{name}.lang
%defattr(-,root,root,-)
%license COPYING
%doc CREDITS
%config (noreplace) %{_sysconfdir}/%{name}/macros
%{_bindir}/rpm*
%{_bindir}/gendiff
%{_includedir}/%{name}
%{_libdir}/%{name}/*
%{_libdir}/%{name}-plugins/*.so
%{_libdir}/librpm*.so*
%{_libdir}/pkgconfig/%{name}.pc
%attr(0755,root,root) %dir /var/lib/%{name}
%attr(0644,root,root) %ghost %config(missingok,noreplace) /var/lib/%{name}/*
%attr(0644,root,root) %ghost /var/lib/%{name}/.*.lock
%{_mandir}/man1/*.1.gz
%{_mandir}/man8/*.8.gz
%{_libdir}/python%{pyt3num}/site-packages/rpm*.egg-info
%{_libdir}/python%{pyt3num}/site-packages/rpm/__init__.py
%{_libdir}/python%{pyt3num}/site-packages/rpm/__pycache__/*.pyc
%{_libdir}/python%{pyt3num}/site-packages/rpm/_rpm.so
%{_libdir}/python%{pyt3num}/site-packages/rpm/transaction.py
%lang(fr) %{_mandir}/fr/man[18]/*.[18]*
%lang(ko) %{_mandir}/ko/man[18]/*.[18]*
%lang(ja) %{_mandir}/ja/man[18]/*.[18]*
%lang(pl) %{_mandir}/pl/man[18]/*.[18]*
%lang(ru) %{_mandir}/ru/man[18]/*.[18]*
%lang(sk) %{_mandir}/sk/man[18]/*.[18]*

#-----------------------------------------------------------------------------
#procedure to convert RPM database from bekeley-db-18.1
#to libdb (berkerley-db-5.3)
#to known the db backend
#rpm -E "%{_db_backend}"
#to know the db path
#rpm -E "%{_dbpath}"
#To convert data base
#rpmdb --rebuilddb --define "_db_backend ndb" 

#=============================================================================
%prep
%setup -q
%patch -P0 -p1

#-----------------------------------------------------------------------------
#building application
%build

%{__tar} xf %{SOURCE1}

#set ndb as the default library
sed -i							\
  -e "/_db_backend/ s/ sqlite/ ndb/g"			\
   macros.in

autoreconf -vif
./configure						\
	PYTHON=python3					\
        --prefix=%{_prefix}				\
        --sysconfdir=%{_sysconfdir}			\
        --sbindir=%{_sbindir}				\
	--mandir=%{_mandir}				\
	--libdir=%{_libdir}				\
	--infodir=%{_infodir}				\
	--sharedstatedir=%{_var}/lib			\
	--localstatedir=%{_var}				\
	--docdir=%{_defaultdocdir}/%{name}-%{version}	\
	--with-vendor="safe"				\
	--enable-posixmutexes				\
	--enable-ndb					\
	--enable-bdb					\
	--enable-sqlite=yes				\
	--with-lua					\
	--with-acl					\
	--with-cap					\
	--with-crypto=openssl				\
	--enable-python					\
	--with-audit=no					\
	--with-dbus=no					\
	--without-selinux				\
	--disable-openmp				\

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make} %{_smp_mflags}

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

%{__make} DESTDIR=%{buildroot} install

%{__mkdir_p} %{buildroot}/var/lib/%{name}
# init an empty database for %ghost'ing for all supported backends
for db in bdb ndb
  do
  ./rpmdb --define "_db_backend ${db}" --dbpath=${PWD}/${db} --initdb
  cp -va ${db}/. %{buildroot}/var/lib/%{name}/
  done

#inserting debuginfo.sh
#need to be investigated later
#cp -f							\
#	debugedit					\
#	scripts/find-debuginfo.sh			\
#	%{buildroot}%{_libdir}/%{name}

#customization
%{__mkdir_p} %{buildroot}%{_prefix}/lib/%{name}/safe
%{__cp} 						\
	%{name}-ok_addon/rpm.safe.macros		\
	%{buildroot}%{_prefix}/lib/%{name}/safe/macros

#setting macros
%{__mkdir_p} %{buildroot}%{_sysconfdir}/%{name}
case "$(uname -m)" in
  "x86_64"	)
    oklib=lib64
    ;;
  "*"		)
    oklib=lib
    ;;
  esac
(
echo    "#macros from %{name} packages"
echo -e "%%_lib\t\t${oklib}"
echo -e "%%_libdir\t%{_prefix}/lib"
) > %{buildroot}%{_sysconfdir}/%{name}/macros

#To remove libtool library
find 							\
	%{buildroot}%{_libdir}				\
	-name \*.la					\
	-delete


#pushd python
#%{__python}						\
#	setup.py					\
#	install						\
#		--root=%{buildroot}			\
#		--optimize=1
#popd

%find_lang	%{name}
#-----------------------------------------------------------------------------
%changelog
